Subject: Re: [PATCH 2/2] contrib/git-resurrect.sh: use hash-agnostic OID pattern

From: Junio C Hamano <[email-masked]>
Date: Thu, 08 Oct 2020 11:29:34 -0700

Jeff King <[email-masked]> writes:

> On Wed, Oct 07, 2020 at 11:44:40PM -0700, Denton Liu wrote:
>
>> diff --git a/contrib/git-resurrect.sh b/contrib/git-resurrect.sh
>> index 57a77c03f9..d843df3afd 100755
>> --- a/contrib/git-resurrect.sh
>> +++ b/contrib/git-resurrect.sh
>> @@ -37,19 +37,18 @@ search_reflog_merges () {
>>  	)
>>  }
>>  
>> -_x40="[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]"
>> -_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
>> +oid_pattern=$(git hash-object --stdin </dev/null | sed -e 's/./[0-9a-f]/g')
> ...
> in both cases we are matching output we asked for, so we really matching
> [0-9a-f]\+ would be correct and sufficient. That's a little simpler. I
> don't feel too strongly either way, though.

Yes.  I think use of _x40 is overrated.

>   Side note: It's a shame that there is no way to convince rev-list not
>   to print the "commit ..." header, which is really what we're avoiding
>   here. We probably should have suppressed it with user-formats when
>   they were introduced, but it's too late to make that change. I wonder
>   if it would be worth adding a command-line option, though. I've often
>   had to hack around this when parsing rev-list output (and sometimes
>   even resort to using git-log if it's a one-off).

Or make "git log" without frills as fast as rev-list, perhaps?

What extra things do we do that makes "log" inherently slower than
"rev-list"?

I do not mind a new option (e.g. --no-header) to "rev-list", though.

Thanks.